#note script must be written to disk and read by sftp command
from subprocess import call, Popen, PIPE
from path import path
import gconf
import sys
import pexpect

WORKPATH = path('/tmp')
URL = "http://www.karmalearning.com"

def exc(cmd,cwd='./'):
    pid = Popen(cmd,stdout=PIPE,stderr=PIPE,cwd=cwd,shell=True)
    result, err =pid.communicate()
    return result, err

def sftp(script, serial_number, folder = None):
    log = open('/tmp/logSFTP','w')
    try:
        pth = WORKPATH / 'script'
        call('rm -rf ' + pth, shell=True)
        call('mkdir -p ' + WORKPATH, shell=True)
        fout = open(pth, 'w')
        fout.write(script)
        fout.close()
    except:
        print >> log,'script failed',sys.exc_info()[:2]
    try:
        authpth = '/home/olpc/.sugar/default/owner.key'
        auth = ' -oIdentityFile=' + authpth
        scrpt = ' -b ' + pth
        srvr =  serial_number + '@schoolserver'
        cmd = 'sftp ' + auth + scrpt + ' ' + srvr
        cmd = 'sftp ' + auth + scrpt + ' ' + srvr
    except:
        print >> log,'failed',sys.exc_info()[:2]
    print >> log, 'sftp', cmd
    try:
        if folder:
            result,err=exc(cmd,cwd=folder)
        else:
           result,err=exc(cmd)
    except:
        print >> log,'exc failed',sys.exc_info()[:2]
    else:
        if result:
            print >> log, 'result',result
        if err:
            print >> log, 'err', err
        print >> log,'exc succeeded'
    log.close()
    return result, err

def ftp(script, url):
    log = open('/tmp/logFtp','w')
    print >> log, 'ftp',script,url
    URL = 'ftp.karmalearning.com'
    cmd = 'ftp '+ URL 
    child = pexpect.spawn(cmd)
    child.expect('(?i)name .*: ')
    if url == 'ltl':
        child.sendline('ltlcontributor')
        child.expect('(?i)Password:')
        child.sendline('ltl!13')
        print >> log, 'password sent'
    else:
        return 1
    child.expect('ftp> ')
    print >> log, 'send script'
    child.sendline(script)
    child.expect('ftp> ')
    print >> log, 'send quit'
    child.sendline('quit')
    print >> log, 'done'
    log.close()
    return 0
